// Mit diesem Vertex-/Fragment-Shader wird die Richtung der Normale
// direkt als Farbe interpretiert.
//
// GZ 2011, TU Clausthal, http://zach.in.tu-clausthal.de/cg_in_schule/


varying vec3 normal;			// wird vom Rasterizer gesetzt

void main()
{
	// Der Vektor in 'normal' muss nicht Einheitslaenge haben;
	// durch Normieren liegen alle Komponenten im Bereich [-1,1]
	vec3 color = normalize( normal );

	// Jetzt noch jede Komponente in den Bereich [0,1] bringen
	color += 1.0;					// wird auf jede Komponente
	color /= 2.0;					// einzeln angewendet
	
	// Als Farbe setzen
	gl_FragColor = vec4( color, 1.0 );
}
