// Dieser Shader modifiziert die Geometrie des gerenderten Objektes,
// indem die Z-Koordinate durch eine Sinus-Funktion bestimmt wird,
// in welche die Zeit und die X-Koordinate eingeht.
// (Man kann sich aehnliche Funktionen auch fuer die anderen Koord.
// ausdenken.)
// Als Fragment-Shader kann man den Default nehmen, oder std.frag .
//
// GZ 2011, TU Clausthal, http://zach.in.tu-clausthal.de/cg_in_schule/


// Wird vom ShaderMaker mit einer fortlaufenden Zeit gesetzt (Einheit = Sekunden)
uniform float time;

// Amplitude der Sinus-Wellen; amplitude = 0.2 sieht schon recht gut aus
uniform float amplitude;

void main( void )
{
	// Wie immer: Farbe durchreichen
	gl_FrontColor = gl_Color;

	// Position temporaer speichern, um sie zu modifizeren
	vec4 pos = gl_Vertex;

	// Sinuswelle entlang X-Richtung auf Z-Koord addieren; die Welle ueber die Zeit verschieben
	pos.z += sin( 5.0 * pos.x + time )*amplitude;

	// Setzen der transformierten Vertex Position
	gl_Position = gl_ModelViewProjectionMatrix * pos;
}
