// Ein Vertex-Shader, der das Objekt mittels einer Schraubenbewegung
// deformiert.
// Als Fragment-Shader kann man den Default nehmen, oder std.frag .
//
// GZ 2011, TU Clausthal, http://zach.in.tu-clausthal.de/cg_in_schule/


// Wird vom ShaderMaker mit einer fortlaufenden Zeit gesetzt (Einheit = Sekunden)
uniform float time;

// Raeumliche Frequenz der Verschraubung ("Staerke der Verwindung");  Werte zwischen 0 und 5 sind brauchbar
uniform float twist;

// Rotationsgeschwindigkeit   (0 = keine Rotation)
uniform float rot_speed;


void main( void )
{
	// Wie immer: Farbe durchreichen
	gl_FrontColor = gl_Color;

	// Rotationsmatrix erstellen; je weiter man auf der X-Achse geht, desto staerker soll rotiert werden -> Schraube
	float t = twist * gl_Vertex.x + (rot_speed * time);
	mat2 screw_trf = mat2(  cos(t) , sin(t) ,
                            -sin(t) , cos(t)  );
    vec2 pos2 = screw_trf * gl_Vertex.yz;					// Y- und Z-Koord um die X-Achse rotieren; 2x2-matrix * 2-vector
	vec4 pos = vec4( gl_Vertex.x, pos2.x, pos2.y, 1.0 );	// neue Vertex-Pos. (in Obj.koord.system)

	// wie immer: Vertex nach Kamera.koord. transormieren
	gl_Position = gl_ModelViewProjectionMatrix * pos;
}
