// Ein Shader, der sog. "Toon Shading" macht, d.h., die Objekte so
// darstellt, dass sie aehnlich wie in einem Cartoon aussehen (hence the name)
//
// Dieser Shader kommt auch mit positional light sources zurecht, daher
// benoetigt er auch die Position der Fragmente in Weltkoord.
//
// GZ 2011, TU Clausthal, http://zach.in.tu-clausthal.de/cg_in_schule/


// Wir brauchen spaeter im Fragment-Shader pro Pixel eine Normale;
// dazu benoetigen wir diese 'varying'-Variable;
// dies ist die einzige Aufgabe das Vertex-Shaders
varying vec3 normal;

// Wir brauchen spaeter im Fragment-Shader auch die Position des Pixels
// in Weltkoord.; dazu folgende 'varying'-Variable, die im Rasterizer dann
// pro Pixel gesetzt wird
varying vec3 surf_pos;

void main()
{
	normal = gl_NormalMatrix * gl_Normal;
	surf_pos = ( gl_ModelViewMatrix * gl_Vertex).xyz;

	gl_Position = ftransform();
} 

